(function ($) {
    'use strict';

    $.each(params.all_sizes.split(','), function (i, val) {

        // Escape colon before initializing thumbs
        val = val.replace(':', '\\:');

        initThumb(val);
    });

    function initThumb(size) {
        var thumb_edit = '#vip-go-thumbnail-edit-' + size,
            x1val = $("input[name='vip_go_thumbnail_edit_" + size + "_x1']").val(),
            y1val = $("input[name='vip_go_thumbnail_edit_" + size + "_y1']").val(),
            x2val = $("input[name='vip_go_thumbnail_edit_" + size + "_x2']").val(),
            y2val = $("input[name='vip_go_thumbnail_edit_" + size + "_y2']").val(),
            tWidth = $("input[name='vip_go_thumbnail_edit_" + size + "_width']").val(),
            tHeight = $("input[name='vip_go_thumbnail_edit_" + size + "_height']").val(),
            thumb_size = size;

        function update_preview(img, selection, thumb) {
            // This is how big the selection image is
            var img_width = $("input[name='vip_go_thumbnail_edit_" + thumb + "_display_width']").val();
            var img_height = $("input[name='vip_go_thumbnail_edit_" + thumb + "_display_height']").val();

            // This is how big the thumbnail preview needs to be
            var thumb_width = $("input[name='vip_go_thumbnail_edit_" + thumb + "_width']").val();
            var thumb_height = $("input[name='vip_go_thumbnail_edit_" + thumb + "_height']").val();

            var scaleX = thumb_width / (selection.width || 1);
            var scaleY = thumb_height / (selection.height || 1);

            // Update the preview image
            $('#vip-go-thumbnail-edit-preview-' + thumb).css({
                width: Math.round(scaleX * img_width) + 'px',
                height: Math.round(scaleY * img_height) + 'px',
                marginLeft: '-' + Math.round(scaleX * selection.x1) + 'px',
                marginTop: '-' + Math.round(scaleY * selection.y1) + 'px'
            });
        }

        $(thumb_edit).imgAreaSelect({
            aspectRatio: tWidth + ':' + tHeight,
            handles: true,

            // Initial selection
            x1: x1val,
            x2: x2val,
            y1: y1val,
            y2: y2val,

            // Update the preview
            onInit: function (img, selection) {
                update_preview(img, selection, thumb_size);
                $('#vip-go-thumbnail-edit-preview-' + thumb_size).show();
            },
            onSelectChange: function (img, selection) {
                update_preview(img, selection, thumb_size);
            },

            // Fill the hidden fields with the selected coordinates for the form
            onSelectEnd: function (img, selection) {
                $('input[name="vip_go_thumbnail_edit_' + thumb_size + '_x1"]').val(selection.x1);
                $('input[name="vip_go_thumbnail_edit_' + thumb_size + '_y1"]').val(selection.y1);
                $('input[name="vip_go_thumbnail_edit_' + thumb_size + '_x2"]').val(selection.x2);
                $('input[name="vip_go_thumbnail_edit_' + thumb_size + '_y2"]').val(selection.y2);
            }
        });
    }

})(jQuery);
